import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;


public class TestHornetUncleanFailure {
	static DataOutputStream out;
	public static void log(String msg)
	{
		try
		{
			out.writeBytes(new Date().toString() + " - controller - " + msg + "\n");
			out.flush();
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}
	
	public static void main(String[] args)
	{
        try {
    		File outF = new File("test.log");
    		FileOutputStream fout = new FileOutputStream(outF, true);
    		out = new DataOutputStream(fout);
        	
        	log("starting sender process");
			Process sendProcess = Runtime.getRuntime().exec("java -classpath hornettest.jar;lib/hornetq-core-client-java5.jar;lib/netty.jar TestHornetClient sender");

			// let a few messages get through
			Thread.sleep(1000 * 10);

			log("starting receiver process");
			Process receiveProcess = Runtime.getRuntime().exec("java -classpath hornettest.jar;lib/hornetq-core-client-java5.jar;lib/netty.jar TestHornetClient receiver");
			// let things go normally for 30 seconds
			Thread.sleep(1000 * 30);
			
			// kill receiver to force unclean shutdown of client
			log("killing receiver process");
			receiveProcess.destroy();

			// let the sender push out a few more messages
			Thread.sleep(1000 * 20);
			
			// start a new receiver
			log("starting receiver process");
			receiveProcess = Runtime.getRuntime().exec("java -classpath hornettest.jar;lib/hornetq-core-client-java5.jar;lib/netty.jar TestHornetClient receiver");
			
			// let things complete normally
			try {
				sendProcess.waitFor();
				receiveProcess.waitFor();
			} catch (InterruptedException e) {
				// ignore
			}
			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
